// code based on Tab X 0.5 enhanced version by Morac, modified by Hemiola SUN, later CPU & onemen

var nsIPrefServiceObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var tabxBranch = "extensions.tabmix.";
var tabxPrefs = nsIPrefServiceObj.getBranch(tabxBranch);

var gTabBarWidth = -1;
var addtabx;
var tabxleft;
var tabscroll;
var hidebutton;
var flexTabs;
var widthFitTitle;
var gTabbarPosition;
var gSingleWindowMode;
var progress;
var tabBarSpace;
var unreadTab;
var optionsToolsMenu;
var alwaysNewTab;
var showIcons;
var showNewTabButton;
var noprogress;
var boldUnread;
var italicUnread;
var underlineUnread;
var useUnreadColor;
var useCurrentColor;
var useProgressColor;
var boldCurrent;
var italicCurrent;
var underlineCurrent;
var gFirefox2DefaultTheme;
var gHideTabBar;

var closeButtonOptions = ["no-button","always","showhover","current","current_hover","always"]

function TMupdateSettings(start)
{
  var tabBrowser = getBrowser();
  if (!tabBrowser || tabxPrefs.prefHasUserValue("setDefault")) return;

  var i;
  var showCloseButton = TMP_getBoolPref(tabxBranch, "tabXMode.enable",  true);
  addtabx =          TMP_getIntPref (tabxBranch, "tabXMode",         1);
  // in old version we use tabXMode = 0 to disable the button
  if (showCloseButton && (addtabx < 1 || addtabx > 5)) {
    addtabx = 1;
    tabxPrefs.setIntPref("tabXMode", 1);
    return;
  }
  tabxleft =         TMP_getBoolPref(tabxBranch, "tabXLeft",         false);
  tabscroll =        TMP_getIntPref (tabxBranch, "tabBarMode",       1);
  if (tabscroll < 0 || tabscroll > 3) {
    tabxPrefs.setIntPref("tabBarMode", 1);
    return;
  }
  hidebutton =       TMP_getBoolPref(tabxBranch, "hideTabBarButton", true);
  tabBrowser.mTabContainer.mTabMaxWidth  =       TMP_getIntPref (tabxBranch, "maxWidth",         250);
  tabBrowser.mTabContainer.mTabMinWidth  =       TMP_getIntPref (tabxBranch, "minWidth",         30);
  if (tabBrowser.mTabContainer.mTabMaxWidth < tabBrowser.mTabContainer.mTabMinWidth) {
    tabxPrefs.setBoolPref("setDefault", true);
    tabxPrefs.setIntPref("maxWidth", tabBrowser.mTabContainer.mTabMinWidth);
    tabxPrefs.setIntPref("minWidth", tabBrowser.mTabContainer.mTabMaxWidth);
    tabxPrefs.clearUserPref("setDefault"); // this trigger TMupdateSettings
    return;
  }
  flexTabs =         TMP_getBoolPref(tabxBranch, "flexTabs",         false);
  widthFitTitle = flexTabs && (tabBrowser.mTabContainer.mTabMaxWidth != tabBrowser.mTabContainer.mTabMinWidth);
  progress =         TMP_getBoolPref(tabxBranch, "progressMeter",    true);
  tabBarSpace =      TMP_getBoolPref(tabxBranch, "tabBarSpace",      false);
  unreadTab =        TMP_getBoolPref(tabxBranch, "unreadTab",        false);
  currentTab =       TMP_getBoolPref(tabxBranch, "currentTab",       false);
  noprogress =       TMP_getBoolPref(tabxBranch, "noprogress",       false);
  optionsToolsMenu = TMP_getBoolPref(tabxBranch, "optionsToolMenu",  true);
  alwaysNewTab =     TMP_getIntPref (tabxBranch, "speLink",          0);
  showIcons =        TMP_getBoolPref(tabxBranch, "extraIcons",       true);
  showNewTabButton = TMP_getBoolPref(tabxBranch, "newTabButton",     true);
  boldUnread =       TMP_getBoolPref(tabxBranch, "boldUnread",       true);
  italicUnread =     TMP_getBoolPref(tabxBranch, "italicUnread",     true);
  underlineUnread =  TMP_getBoolPref(tabxBranch, "underlineUnread",  true);
  boldCurrent =      TMP_getBoolPref(tabxBranch, "boldCurrent",      true);
  italicCurrent =    TMP_getBoolPref(tabxBranch, "italicCurrent",    true);
  underlineCurrent = TMP_getBoolPref(tabxBranch, "underlineCurrent", true);
  useCurrentColor =  TMP_getBoolPref(tabxBranch, "useCurrentColor",  true);
  useUnreadColor =   TMP_getBoolPref(tabxBranch, "useUnreadColor",   true);
  useProgressColor = TMP_getBoolPref(tabxBranch, "useProgressColor", false);

  var allTabs = tabBrowser.mTabContainer.childNodes;
  var tabBar  = tabBrowser.mTabContainer;
  var tabBox  = tabBrowser.mTabBox;

  var currentVisible = start ? true : tabBar.isTabVisible(tabBrowser.mCurrentTab._tPos);

  tabBox.setAttribute("dir", gTabbarPosition == 1 ? "rtl" : "ltr");
  // fix bug in positioning  the popup off screen or on the button when window is not maximize or when tab bar is in the botton
  TMP_setItem(tabBar.mAllTabsPopup, "position",
            (window.windowState != window.STATE_MAXIMIZED || gTabbarPosition == 1) ? "start_before" : "after_end");

  switch ( tabscroll ) {
    case 0:
      tabBar.setAttribute("flowing", "singlebar");
      if (gIsFirefox3)
        tabBar.overflow = false;
      break;
    case 1:
      if (!tabBar.hasAttribute("scrollbutton-up"))
        tabBar.setAttribute("scrollbutton-up", "left");
    case 3:
      if (tabBar.getAttribute("flowing") != "scrollbutton") {
        tabBar.setAttribute("flowing", "scrollbutton");
        if (gIsFirefox3)
          tabBar.overflow = tabBar.canScrollTabsLeft || tabBar.canScrollTabsRight;
      }
      break;
    case 2:
      if (tabBar.getAttribute("flowing") != "multibar") {
         tabBar.setAttribute("flowing", "multibar");
         if (!start || tabBar.collapsedTabs > 0)
           tabBar.collapsedTabs = 0;
      }
      break;
  }

  if (tabscroll != 1 && tabBar.hasAttribute("scrollbutton-up"))
    tabBar.removeAttribute("scrollbutton-up");

  if (gIsFirefox2)
    TMP_setItem("tabs-arrowscrollbox", "orient", tabscroll == 2 ? "vertical" : "horizontal");

  if (tabBar.collapsedTabs > 0 && !flexTabs)
    tabBar.collapsedTabs = 0;

  for (i = 0; i < allTabs.length; i++) {
    var aTab = allTabs[i];

    aTab.maxWidth = tabBrowser.mTabContainer.mTabMaxWidth;
    aTab.style.maxWidth = tabBrowser.mTabContainer.mTabMaxWidth + "px";
    aTab.minWidth = tabBrowser.mTabContainer.mTabMinWidth;
    if (widthFitTitle) {
      if (aTab.hasAttribute("width")) aTab.removeAttribute("width");
      if (aTab.hasAttribute("flex")) aTab.removeAttribute("flex");
    } else {
      TMP_setItem(aTab, "width", "0");
      TMP_setItem(aTab, "flex", "100");
    }

    if ( alwaysNewTab == 1) {
      // when we can change user locked / unlock tabs
      var changeUserLockStatus = (start && aTab.getAttribute("_locked") != "false") ||
                          (!start && tabBar.getAttribute("lockAllTab") != "true")    
      if (changeUserLockStatus) {
        aTab.setAttribute("locked", "true");
        aTab.removeAttribute("_locked");
      }
    }
    else if ( tabBar.getAttribute("lockAllTab") == "true" ) {
      aTab.removeAttribute("locked");
      aTab.removeAttribute("_locked");      
    }

    SessionManager.updateTabProp(aTab);

    if (showCloseButton)
       aTab.setAttribute("tabx", closeButtonOptions[addtabx]);
    else
       aTab.removeAttribute("tabx");

    if (tabxleft)
       aTab.setAttribute("tabxleft", "on");
    else
       aTab.removeAttribute("tabxleft");
  }

  tabBar.setAttribute("closebutton", !hidebutton);
  tabBar.setAttribute("hideAllTabsButton", TMP_getBoolPref(tabxBranch, "hideAllTabsButton", false));
  tabBar.setAttribute("progressMeter", progress);
  tabBar.setAttribute("tabBarSpace", tabBarSpace);
  tabBar.setAttribute("unreadTab", unreadTab);
  tabBar.setAttribute("extraIcons", showIcons );
  tabBar.setAttribute("lockAllTab", alwaysNewTab == 1 );
  tabBar.setAttribute("newTabButton", showNewTabButton );
  tabBar.setAttribute("boldUnread", boldUnread);
  tabBar.setAttribute("italicUnread", italicUnread);
  tabBar.setAttribute("underlineUnread", underlineUnread);
  tabBar.setAttribute("boldCurrent", boldCurrent);
  tabBar.setAttribute("italicCurrent", italicCurrent);
  tabBar.setAttribute("underlineCurrent", underlineCurrent);
  tabBar.setAttribute("currentTab", currentTab);
  tabBar.setAttribute("useCurrentColor", useCurrentColor);
  tabBar.setAttribute("useUnreadColor", useUnreadColor);
  tabBar.setAttribute("useProgressColor", useProgressColor);
  document.getElementById("statusbar-progresspanel").setAttribute("hidden", noprogress && progress);

  if (tabBar.tabstrip.style.maxHeight != "none" && !gBrowser.mStrip.collapsed && tabBar.firstChild.collapsed) {
    var currentMaxRow = tabBar.tabstrip.style.maxHeight.replace("px", "") / getRowHeight();
    var rowDiff = tabBar.maxRow - currentMaxRow;
    while (tabBar.firstChild.collapsed && rowDiff > 0) {
      tabBar.rowScroll(-1);
      rowDiff--;
    }
  }

  if (start && "isLoadHomePage" in window) {
    window.setTimeout(tabBarScrollStatus, 0);
    delete window.isLoadHomePage;
  }
  else
    tabBarScrollStatus();

  tabBar.canScrollTabsLeft = tabBar.firstChild.collapsed;
  window.setTimeout( function TMupdateSettings_currentVisible() {
                         if (currentVisible)
                           tabBar.ensureTabIsVisible(tabBrowser.mTabContainer.selectedIndex);
                           tabBar.canScrollTabsRight = tabBar.boxObject.width == 0 ? false : !tabBar.lastTabVisible;
                           checkBeforeAndAfter();
                       }, 50 );

  // if the current Browser has SafeBrowsing problem and message is showing we need to
  // repaint the "safebrowsing-dim-area-canvas"
  window.setTimeout(adjustSafebrowsingDimArea, 0);

  // set some items
  document.getElementById("tabmix-menu").hidden = !optionsToolsMenu;

  TMP_LastTab.ReadPreferences();
  SessionManager.updateSettings(); // this update all open windows, if we fix here we need to change in SessionManager
}

function TMP_SSTabRestoring(event){
  var aTab = event.target;
  if (aTab.hasAttribute("_locked")) {
    if (aTab.getAttribute("_locked") == "true")
      aTab.setAttribute("locked", "true");
    else
      aTab.removeAttribute("locked");
  }

  // this function run befor tab load, so onTabReloaded will run at onStateChange get STATE_STOP
  var reloadData = aTab.getAttribute("reload-data");
  if (reloadData) {
    reloadData = reloadData.split(" ");
    gBrowser.setupAutoReload(aTab);
    aTab.autoReloadEnabled = true;
    aTab.autoReloadURI = reloadData[0];
    aTab.autoReloadTime = reloadData[1];
  }
}

// Function to catch when a new window is created and update icons if needed
//
function tabxOnLoad(event)
{
  var tabBar = getBrowser().mTabContainer;

  if (/^Mac/.test(navigator.platform))
    tabBar.setAttribute("firefox2Mac", "true");
  else
    tabBar.setAttribute("firefox2notMac", "true");

  var skin = gPref.getCharPref("general.skins.selectedSkin");
  if (skin=="classic/1.0") {
    gFirefox2DefaultTheme = !gIsFirefox3;
    if (/^Mac/.test(navigator.platform))
      tabBar.setAttribute("classic", gIsFirefox3 ? "v3Mac" : "v2Mac");
    else if (/^Linux/.test(navigator.platform)) {
      tabBar.setAttribute("classic", gIsFirefox3 ? "v3Linux" : "v2");
      if (gIsFirefox3)
        tabBar.setAttribute("platform", "linux");
    }
    else {
      tabBar.setAttribute("classic", gIsFirefox3 ? "v3" : "v2");
      tabBar.setAttribute("platform", "xp");
    }
  }
   // for new tab icon on context menu
   TMP_setItem("context_newTab", "platform", tabBar.getAttribute("platform"));

  // adjust attribute when we close 2nd tab (we left with only one) or when we open 2nd tab
  if (numberOfWindows() > 1)
    adjustOn2ndTab.closeButton(1);

  if (gSingleWindowMode)
    tabxPrefObserver.setSingleWindowUI();

  tabxPrefObserver.setMenuIcons();
  tabxPrefObserver.toggleKey("key_tm_slideShow", "extensions.tabmix.disableF8Key");
  tabxPrefObserver.toggleKey("key_tm_toggleFLST", "extensions.tabmix.disableF9Key");
  tabxPrefObserver.setNewColorCode("currentTab", "extensions.tabmix.currentColor", "#000000");
  tabxPrefObserver.setNewColorCode("unreadTab", "extensions.tabmix.unreadColor", "#CC0000");
  tabxPrefObserver.setNewColorCode("progress", "extensions.tabmix.progressColor", "#AAAAFF");
  tabxPrefObserver.tabCloseButton();
  tabxPrefObserver.updateSettings();
  TMP_ClosedTabs.setButtonType(tabxPrefs.getBoolPref("undoCloseButton.menuonly"));

  gHideTabBar = tabxPrefs.getIntPref("hideTabbar");
 /*
  *  In the first time TMP is running we need to match extensions.tabmix.hideTabbar to browser.tabs.autoHide.
  *  extensions.tabmix.hideTabbar default is 1 > Hide tabbar when i have only one tab
  *  if browser.tabs.autoHide is false we need to make sure extensions.tabmix.hideTabbar is 0 > Neve Hide tabbar
  */
  if (!gPref.getBoolPref("browser.tabs.autoHide") && gHideTabBar == 1) {
    gHideTabBar = 0;
    tabxPrefs.setIntPref("hideTabbar", gHideTabBar);
  }
  window.setTimeout( function () {
                        // initialize the value of "gTabBarWidth"
                        gTabBarWidth = gBrowser.mTabContainer.boxObject.width;
                        // only hide the tabbar after we catch the width
                        if (gHideTabBar == 2)
                          gBrowser.mTabContainer.collapsed = true;
                      }, 100 );

  gTabbarPosition = TMP_getIntPref (tabxBranch, "tabBarPosition", 0);

  // In XP default theme alltabs-button is the highest object is the tab strip
  // we need  place-holder for the height in case the user hide alltabs-buttin
  if (gIsFirefox3)
    document.getElementById("alltabs-place-holder").setAttribute("height", tabBar.mAllTabsButton.parentNode.boxObject.height);

  // update icons if needed
  TMupdateSettings(true); // xxx we need diff function that call one on new window(s) and one for pref changed
}

function tabxOnClose()
{
  var tabBar = getBrowser().mTabContainer;
  tabBar.removeEventListener("SSTabRestoring", TMP_SSTabRestoring, true);
  tabBar.removeEventListener("DOMNodeInserted", tabxTabAdded, true);
  tabBar.removeEventListener("TabClose", tabxTabClosed, true);
  tabBar.removeEventListener("DOMMouseScroll", TMtabBarScroll, false);
  if (/^Linux/.test(navigator.platform))
    document.getElementById("navigator-toolbox").removeEventListener("DOMMouseScroll", TMtabBarScroll, false);
}

function tabxTabClosed(event)
{
  // aTab is the tab we are closing now
  var aTab = event.target;

  var tabs = gBrowser.mTabContainer.childNodes;
  var tabBar = gBrowser.mTabContainer;

  if (aTab.getAttribute("image") != gBrowser.getBrowserForTab(aTab).mIconURL)
    aTab.setAttribute("image", gBrowser.getBrowserForTab(aTab).mIconURL);

  if (aTab.label == gBrowser.mStringBundle.getString("tabs.loading"))
    gBrowser.setTabTitle(aTab);

  // adjust attribute when we close 2nd tab
  adjustOn2ndTab.closeButton(2, aTab);

  // if we close the 2nd tab and browser.tabs.autoHide is true reset all scroll and multi-row parameter
  // strip already collapsed at this point
  if (tabs.length == 2 && gPref.getBoolPref("browser.tabs.autoHide")) {
    gBrowser.mTabContainer.collapsedTabs = 0;
    setTabBarHeight(false);
    tabBar.removeAttribute("multibar");
  }

  if ( tabscroll != 2 ) {
    var _canScrollTabsRight = tabBar.canScrollTabsRight;
    tabBar.collapsedTabs--;
    if (!_canScrollTabsRight)
      tabBar.canScrollTabsRight = false;
    window.setTimeout( function() {
                         tabBar.canScrollTabsRight = tabBar.boxObject.width == 0 ? false : !tabBar.lastTabVisible;
                       }, 50 );
  }
  else {
    window.setTimeout( function(removeCollapsedTab) {
       if (removeCollapsedTab)
         tabBar.collapsedTabs--;
       else if ( tabBar.getAttribute("multibar") == "scrollbar" && tabBar.firstChild.collapsed) {
          if ((tabBar.lastChild.baseY + tabBar.lastChild.boxObject.height/2) < (tabBar.boxObject.y + tabBar.boxObject.height)) {
                tabBar.rowScroll(-1);
          }
       }
       if (tabBar.hasAttribute("multibar"))
         tabBarScrollStatus();
       checkBeforeAndAfter();
    }, 0, aTab._tPos < tabBar.collapsedTabs);
  }

  // if the current Browser has SafeBrowsing problem and message is showing we need to
  // repaint the "safebrowsing-dim-area-canvas"
  window.setTimeout(adjustSafebrowsingDimArea, 0);
}

// Function to catch when new tabs are created and update tab icons if needed
// In addition clicks and doubleclick events are trapped.
//
function tabxTabAdded(event)
{
  if (event.target.localName != "tab" || event.target.hasAttribute("tabmoved"))
    return;

   var aTab = event.target;

   // XXX splice, appendChild, insertBefore from gBrowser.moveTabTo
   // trigger tabxTabClosed and tabxTabAdded
   if (aTab._added) {
      delete aTab._added;
      return;
   }

   aTab._added = true;

   //XXX when we drop support for Fx 1.0 - 1.5 add chromedir="&locale.dir;" to tab content binding
   if (gIsFirefox2 && !gIsFirefox3)
     aTab.setAttribute("chromedir", gChromeDir);

   // adjust attribute when we close 2nd tab (we left with only one) or when we open 2nd tab
   adjustOn2ndTab.closeButton(1);

   var showCloseButton = tabxPrefs.getBoolPref("tabXMode.enable");
   if (showCloseButton)
     aTab.setAttribute("tabx", closeButtonOptions[addtabx]);
   else
     aTab.removeAttribute("tabx");

   if (tabxleft)
      aTab.setAttribute("tabxleft", "on");
   else
      aTab.removeAttribute("tabxleft");

   if ( alwaysNewTab == 1 )
     aTab.setAttribute("locked", "true");
     // XXX SessionManager.updateTabProp(aTab); // tab is blank at this stage

   if (gBrowser.mTabContainer.getAttribute("multibar") != "scrollbar")
     tabBarScrollStatus();
   checkBeforeAndAfter();

   // if the current Browser has SafeBrowsing problem and message is showing we need to
   // repaint the "safebrowsing-dim-area-canvas"
   adjustSafebrowsingDimArea();
}

function tabBarScrollStatus ()
{
  var tabBar = gBrowser.mTabContainer;
  if (tabBar.boxObject.width == 0)
    return;

  tabBar.canScrollTabsLeft = tabBar.firstChild.collapsed;

  var multibar;
  if ( tabscroll == 2 ) {
    multibar = getMultiRowAttribute();
  }

  TMP_setItem(tabBar, "multibar", multibar); // if multibar is null we remove the attribute
  setTabBarHeight(multibar);

  tabBar.canScrollTabsRight = tabBar.boxObject.width == 0 ? false : !tabBar.lastTabVisible;
}

function getMultiRowAttribute ()
{
  var tabBar = gBrowser.mTabContainer;
  if (tabBar.collapsedTabs > 0)
    return "scrollbar";

  if (gBrowser.mStrip.collapsed || (tabBar.lastTabVisible && inSameRow(tabBar.firstChild, tabBar.lastChild)))
    return null; // tabBar.removeAttribute("multibar");

  tabBar.setAttribute("multibar", "true");
  var maxY = tabBar.tabstrip.boxObject.y + getRowHeight() * tabBar.maxRow;
  // if the top of the last tab is on or below the max line then enter scrollbar
  var lastTabY = tabBar.lastChild.boxObject.y;
  if (lastTabY >= maxY)
    return "scrollbar";

  return "true";
}

function setTabBarHeight (multibar) {
  var tabhbox = gBrowser.mTabContainer.tabstrip;
  var newHeight;
  if (multibar == "true" && gIsFirefox3) {
   // check bottom of 2 last tab just in case theme set different bottom to selected or hover tab
   var tabs = gBrowser.mTabContainer.childNodes;
   var tabBottom = Math.max(tabs[tabs.length - 1].baseY, tabs[tabs.length - 2].baseY);
    newHeight = tabBottom - tabhbox.boxObject.y;
    if (tabhbox.boxObject.height > newHeight && tabhbox.boxObject.height - newHeight < 2)
      return;
    if (tabhbox.style.maxHeight != tabhbox.style.height || tabhbox.style.maxHeight != newHeight)
       tabhbox.style.maxHeight = tabhbox.style.height = newHeight + "px";
  }
  else if (multibar == "scrollbar") {
    newHeight = getRowHeight() * gBrowser.mTabContainer.maxRow + "px";
    if (tabhbox.style.maxHeight != tabhbox.style.height || tabhbox.style.maxHeight != newHeight)
       tabhbox.style.maxHeight = tabhbox.style.height = newHeight;
  }
  else if (tabhbox.hasAttribute("style"))
    tabhbox.removeAttribute("style");
}

// Update beforeselected and afterselected attribute when we are in multi-row mode
function checkBeforeAndAfter()
{
  var tabBar = getBrowser().mTabContainer;
  if (!tabBar.hasAttribute("multibar"))
     return;

  var tab = tabBar.selectedItem;
  var prev = tab.previousSibling, next = tab.nextSibling;
  if (prev) {
    TMP_setItem(prev, "beforeselected", inSameRow(prev, tab) ? true : null)
  }
  if (next) {
    TMP_setItem(next, "afterselected", inSameRow(next, tab) ? true : null)
  }
}

var gRowHeight = null;
function getRowHeight ()
{
  if (gRowHeight)
    return gRowHeight;

  var tabBar = getBrowser().mTabContainer;
  var tabs = getBrowser().mTabContainer.childNodes;

  var i, j;
  i = j = tabBar.collapsedTabs;
  if ( tabs[j] && tabs[j].getAttribute("selected") == "true" )
    j++;
  while (tabs.item(j) && tabs.item(i) && inSameRow( tabs.item(i), tabs.item(j) ) )
    i++;

  if ( !tabs[i] ) // only one row
    if ( tabs[j] )
      return tabs[j].baseY - tabs[j].boxObject.y;
    else
      return tabs[0].baseY - tabs[0].boxObject.y;

  if ( tabs[i].getAttribute("selected") == "true" )
    i++;
  if ( !tabs[i] )
    return tabs[i-1].baseY - tabs[i-1].boxObject.y;

  gRowHeight = tabs[i].baseY - tabs[j].baseY;
  return gRowHeight;
}

function inSameRow (tab1, tab2)
{
  if ( !tab1 || !tab2 )
    return false;
  if ( !tabscroll || tabscroll != 2 )
    return true;

  var top1 = tab1.boxObject.y, top2 = tab2.boxObject.y;
  var base1 = tab1.baseY, base2 = tab2.baseY;
  var topH = Math.min(top1, top2), topL = Math.max(top1, top2);
  var baseH = Math.min(base1, base2), baseL = Math.max(base1, base2);

  if ( topH == topL || baseH == baseL )
    return true;

  return ( baseH > (top1+base1)/2 && baseH > (top2+base2)/2 && topL < (top1+base1)/2 && topL < (top2+base2)/2 ) ?
    true : false;
}

// call by resize event on content
function tabBarWidthChange (aEvent) {
  var tabBar = gBrowser.mTabContainer;

  // fix bug in positioning  the popup off screen or on the button when window is not maximize or when tab bar is in the botton
  TMP_setItem(tabBar.mAllTabsPopup, "position",
            (window.windowState != window.STATE_MAXIMIZED || gTabbarPosition == 1) ? "start_before" : "after_end");

  // we don't need to update scroll status if resize event not trigger by width change or when tab bar is in collapsed mode
  if ( gTabBarWidth == tabBar.boxObject.width || tabBar.boxObject.width == 0)
    return;

  var tabs = gBrowser.mTabContainer.childNodes;

  if (addtabx == 5 && !flexTabs)
    adjustOn2ndTab.closeButton(1);

  var oldCollapsed = tabBar.collapsedTabs;
  var i = 0;
  if ( tabscroll != 2 && gTabBarWidth < tabBar.boxObject.width ) {
    while ( tabs[ oldCollapsed + i ] &&
            tabs[ oldCollapsed + i ].boxObject.x + tabs[ oldCollapsed + i ].boxObject.width <
              tabBar.tabstrip.boxObject.x + tabBar.tabstrip.boxObject.width ) {
      i++;
    }
    if (tabBar.collapsedTabs > 0)
      tabBar.collapsedTabs = 0;
    tabBar.ensureTabIsVisible( oldCollapsed + i - 1 );
    tabBarScrollStatus();
  }
  else if ( tabscroll == 2 ) {
    if (tabBar.collapsedTabs > 0)
      tabBar.collapsedTabs = 0;
    tabBarScrollStatus();
    tabBar.ensureTabIsVisible( tabs.length - 1);
    tabBar.ensureTabIsVisible( oldCollapsed );
    checkBeforeAndAfter();
  }
  else
    tabBarScrollStatus();

  gTabBarWidth = tabBar.boxObject.width;
}

// Function to catch changes to Tab Mix preferences and update existing windows and tabs
//
function tabxPrefObserver() {
  var pref = "setDefault"
  if (tabxPrefs.prefHasUserValue(pref)) tabxPrefs.clearUserPref(pref)
  pref = "PrefObserver.error";
  if (tabxPrefs.prefHasUserValue(pref)) tabxPrefs.clearUserPref(pref)
  try {
    var prefSvc = nsIPrefServiceObj.getBranch(null);
    this.tabxBranch = tabxBranch;
    this.pbi = prefSvc.QueryInterface(Components.interfaces.nsIPrefBranch2);

    // add Observer
    for (var i = 0; i < this.OBSERVING.length; ++i)
      this.pbi.addObserver(this.OBSERVING[i], this, true);
  }
  catch(e) {
    tmLog("prefs-Observer failed to attach:" + "\n" + e);
    tabxPrefs.setBoolPref(pref, true);
  }
}

tabxPrefObserver.prototype = {
  tabxBranch: null,
  // nsISupports interface implementation -- for weak-reference by pref-observer service
  QueryInterface: function(iid) {
    if (!iid.equals(Components.interfaces.nsISupports)
        && !iid.equals(Components.interfaces.nsISupportsWeakReference)
        && !iid.equals(Components.interfaces.nsIObserver)) {
      dump("Tab Mix Plus pref-observer factory object: QI unknown interface: " + iid + "\n");
      throw Components.results.NS_ERROR_NO_INTERFACE;
    }
    return this;
  },

  OBSERVING: ["extensions.tabmix.",
              "browser.tabs.autoHide",
              "browser.tabs.tabClipWidth",
              "browser.sessionstore.max_tabs_undo",
              "browser.warnOnRestart",
              "browser.warnOnQuit",
              "browser.sessionstore.resume_from_crash",
              "browser.sessionstore.resume_session_once",
              "browser.startup.page",
              "browser.link.open_external",
              "browser.link.open_newwindow.restriction",
              "browser.link.open_newwindow"],

  // removes the observer-object from service -- called when the window is no longer open
  removeObserver: function() {
    for (var i = 0; i < this.OBSERVING.length; ++i)
      this.pbi.removeObserver(this.OBSERVING[i], this);

    this.pbi = null;
  },

  /* Observer-function */
  /* subject: [wrapped nsISupports :: nsIPrefBranch], nsIPrefBranch Internal
     topic: "changed"*/
  observe: function TMP_pref_observer(subject, topic, prefName) {
    // if we don't have a valid window (closed)
    if ( !(typeof(document) == 'object' && document) ) {
      this.removeObserver(); // remove the observer..
      return;  // ..and don't continue
    }

    var prefValue;
    switch (prefName) {
      case "extensions.tabmix.warnAboutClosingTabs.timeout":
      case "extensions.tabmix.sessions.crashed":
      case "extensions.tabmix.disableIncompatible":

      case "extensions.tabmix.selected_tab":
      case "extensions.tabmix.selected_sub_tab1":
      case "extensions.tabmix.selected_sub_tab2":
      case "extensions.tabmix.selected_sub_tab3":
      case "extensions.tabmix.selected_sub_tab4":
      case "extensions.tabmix.selected_sub_tab5":
      case "extensions.tabmix.selected_sub_tab6":

      case "extensions.tabmix.reload_time":
      case "extensions.tabmix.custom_reload_time":
      case "extensions.tabmix.resume_session_once":
        break;
      case "extensions.tabmix.undoCloseButton.menuonly":
        TMP_ClosedTabs.setButtonType(gPref.getBoolPref(prefName));
        break;
      case "extensions.tabmix.focusTab":
        if (gIsFirefox2)
          gPref.setBoolPref("browser.tabs.selectOwnerOnClose", gPref.getIntPref(prefName) == 2);
        break;
      case "extensions.tabmix.disableF9Key":
        this.toggleKey("key_tm_toggleFLST", prefName);
        break;
      case "extensions.tabmix.disableF8Key":
        this.toggleKey("key_tm_slideShow", prefName);
        break;
      case "extensions.tabmix.hideIcons":
        this.setMenuIcons();
        break;
      case "extensions.tabmix.currentColorCode":
        this.setColor("currentTab", prefName, "#009900");
        break;
      case "extensions.tabmix.unreadColorCode":
        this.setColor("unreadTab", prefName, "#FF0000");
        break;
      case "extensions.tabmix.progressColorCode":
        this.setColor("progress", prefName, "#AAAAFF");
        break;
      case "extensions.tabmix.flexTabs":
      case "extensions.tabmix.tabXMode":
        TMupdateSettings(false);
      case "extensions.tabmix.keepLastTab":
      case "browser.tabs.tabClipWidth":
        adjustOn2ndTab.closeButton(1);
        break;
      case "extensions.tabmix.tabBarPosition":
         gTabbarPosition = TMP_getIntPref (tabxBranch, "tabBarPosition", 0);
         adjustSafebrowsingDimArea();
        break;
      case "extensions.tabmix.useGreyCloseButton":
        this.tabCloseButton();
        break;
      case "extensions.tabmix.undoClose":
        if (!tabxPrefs.getBoolPref("undoClose")) {
          gPref.setIntPref("browser.sessionstore.max_tabs_undo", 0);
        }
        else if (gPref.prefHasUserValue("browser.sessionstore.max_tabs_undo"))
          gPref.clearUserPref("browser.sessionstore.max_tabs_undo");
        break;
      case "browser.sessionstore.max_tabs_undo":
        prefValue = gPref.getIntPref(prefName);
        while (prefValue < gBrowser.closedTabs.length) {
          getClosedTab("delete", 0);
        }
        if (tabxPrefs.getBoolPref("undoClose") != (prefValue > 0))
          tabxPrefs.setBoolPref("undoClose", prefValue > 0);
        break;
      case "browser.warnOnRestart":
      case "browser.warnOnQuit":
      case "browser.sessionstore.resume_from_crash":
      case "browser.sessionstore.resume_session_once":
        if (!gPref.getBoolPref(prefName))
          return;
        var TMP_sessionManager_enabled = tabxPrefs.getBoolPref("sessions.manager") ||
                         tabxPrefs.getBoolPref("sessions.crashRecovery");

        if (TMP_sessionManager_enabled)
          gPref.setBoolPref(prefName, false);
        break;
      case "browser.startup.page":
        if (gPref.getIntPref(prefName) != 3)
          return;
        TMP_sessionManager_enabled = tabxPrefs.getBoolPref("sessions.manager") ||
                         tabxPrefs.getBoolPref("sessions.crashRecovery");

        if (TMP_sessionManager_enabled)
          gPref.setIntPref(prefName, 1);
        break;
      case "extensions.tabmix.sessions.manager":
      case "extensions.tabmix.sessions.crashRecovery":
        TMP_SessionStore.setService(2, false);
        SessionManager.updateSettings();
        break;
      case "browser.link.open_external":
      case "browser.link.open_newwindow.restriction":
      case "browser.link.open_newwindow":
        this.setLink_openPrefs();
        break;
      case "extensions.tabmix.singleWindow":
        this.setSingleWindowUI();
        break;
      case "extensions.tabmix.hideTabbar":
        this.setTabBarVisibility();
        break;
      case "browser.tabs.autoHide":
        this.setAutoHidePref();
        break;
      case "extensions.tabmix.keepWindow":
        break;
      default:
        TMupdateSettings(false);
    }

  },

  tabCloseButton: function() {
    /* Mac from Firefox 2 and Linux from Firefox 3 don't use close.png */
    var dontUseForPlatform  = /^Mac/.test(navigator.platform) || (/^Linux/.test(navigator.platform) && gIsFirefox3);
    if (dontUseForPlatform)
      return;

    try {
      var useNewCloseIcon = tabxPrefs.getBoolPref("useGreyCloseButton");
    }
    catch(er) { useNewCloseIcon = true; }
    if (useNewCloseIcon) {
//      gBrowser.mTabContainer.setAttribute("closeIcon", gIsFirefox3 ? "v3" : "v2");
      // temp fix to work with 3.0b4
      var appInfo = Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULAppInfo);
      var versionChecker = Cc["@mozilla.org/xpcom/version-comparator;1"].getService(Ci.nsIVersionComparator);
      var closeIcon = versionChecker.compare(appInfo.version, "3.0b4") > 0 && appInfo.appBuildID >= "2008032104";
      gBrowser.mTabContainer.setAttribute("closeIcon", closeIcon ? "v3" : "v2");
    }
    else
      gBrowser.mTabContainer.removeAttribute("closeIcon");
  },

  toggleKey: function(keiID, prefName) {
    var key = document.getElementById(keiID);
    if (TMP_getBoolPref("", prefName, false)) {
      if (key.hasAttribute("oncommand"))
        key.removeAttribute("oncommand");
    } else
      key.setAttribute("oncommand", key.getAttribute("TM_oncommand"));
  },

  // in 0.3.0.605 we changed tab color from old pref to new pref
  // old pref "extensions.tabmix.currentColor" type integer
  // new pref "extensions.tabmix.currentColorCode" type string
  setNewColorCode: function(colorType, OldprefName, defaultPref) {
    var prefName = OldprefName + "Code";

    if (gPref.prefHasUserValue(OldprefName)) {
      var colorCodes = ["#CF1919", "#0E36EF", "#DDDF0D", "#3F8F3E", "#E066FF", "#86E7EF",
                         "#FFFFFF", "#7F7F7F", "#000000", "#EF952C", "#FF82AB", "#7F4C0F", "#AAAAFF"];
      var colorCode = colorCodes[gPref.getIntPref(OldprefName)];
      gPref.clearUserPref(OldprefName);
      if (gPref.getCharPref(prefName) != colorCode) {
         gPref.setCharPref(prefName , colorCode); // this trigger call to setColor for this prefName
         return;
      }
    }
    this.setColor(colorType, prefName, defaultPref);
  },

  colorRules: {},
  setColor: function(colorType, prefName, defaultPref) {
    var colorCode = TMP_getCharPref("", prefName, defaultPref);
    var colorRule, _style;

    switch (colorType) {
      case "currentTab":
         _style = "color";
        colorRule = 'tabs[currentTab=true][useCurrentColor=true] tab[selected="true"] .tab-text { color:' + colorCode + '}';
        break;
      case "unreadTab":
         _style = "color";
        colorRule = 'tabs[unreadTab=true][useUnreadColor=true] tab:not([selected]) .tab-text { color:' + colorCode + '}';
        break;
      case "progress":
         _style = "backgroundColor";
        colorRule = 'tabs[useProgressColor=true] tab .progress-bar { background-color:' + colorCode + '}';
        break;
    }

    var ss = document.styleSheets[0];

    if (this.colorRules[colorType])
      this.colorRules[colorType].style[_style] = colorCode;
    else
    {
      var index = ss.insertRule(colorRule, ss.cssRules.length);
      this.colorRules[colorType] = ss.cssRules[index];
    }
  },

  setLink_openPrefs: function() {
    if (!gSingleWindowMode)
      return;

    function updateStatus(pref, testVal, test, newVal) {
      try {
        var prefValue = gPref.getIntPref(pref);
        test = test ? prefValue == testVal : prefValue != testVal
      }
      catch(e){ test = true; }

      if (test)
        gPref.setIntPref(pref, newVal);
    }

    updateStatus("browser.link.open_external", 2, true, 3);
    updateStatus("browser.link.open_newwindow.restriction", 0, false, 0);
    updateStatus("browser.link.open_newwindow", 2, true, 3);
  },

  // code for Single Window Mode...
  // disable the "Open New Window action
  //disable & hides some menuitem
  setSingleWindowUI: function() {
    gSingleWindowMode = TMP_getBoolPref(tabxBranch, "singleWindow", false);
    var newWindowButton = document.getElementById("new-window-button");
    if (newWindowButton)
      newWindowButton.setAttribute("disabled", gSingleWindowMode);

    var openLink = document.getElementById("context-openlink");
    if (openLink)
      openLink.setAttribute("disabled", gSingleWindowMode);

    var menuItem;
    var menuFile = document.getElementById("menu_FilePopup");
    if (menuFile) {
      menuItem = menuFile.getElementsByAttribute("command", "cmd_newNavigator")[0];
      if (menuItem)
        menuItem.setAttribute("hidden", gSingleWindowMode);
    }

    var frameMenu = document.getElementById("frame");
    if (frameMenu) {
      menuItem = frameMenu.getElementsByAttribute("oncommand", "gContextMenu.openFrame();")[0];
      if (menuItem)
        menuItem.setAttribute("hidden", gSingleWindowMode);
    }

    document.getElementById("tmOpenInNewWindow").hidden = gSingleWindowMode;
  },

  setMenuIcons: function() {
    function setClass(items, hideIcons) {
      if (hideIcons)
        for (var i = 0; i < items.length; ++i)
          items[i].removeAttribute("class");
      else
        for ( i = 0; i < items.length; ++i)
          items[i].setAttribute("class", items[i].getAttribute("tmp_iconic"));
    }
    var hideIcons = TMP_getBoolPref(tabxBranch, "hideIcons", false);
    var iconicItems = document.getElementsByAttribute("tmp_iconic", "*");
    setClass(iconicItems, hideIcons);

    iconicItems = document.getElementById("menuedit-tabContextMenu").getElementsByAttribute("tmp_iconic", "*");
    setClass(iconicItems, hideIcons);
  },

  setAutoHidePref: function() {
    gHideTabBar = tabxPrefs.getIntPref("hideTabbar");
    var autoHide = gHideTabBar != 0;
    if (autoHide != gPref.getBoolPref("browser.tabs.autoHide"))
      gPref.setBoolPref("browser.tabs.autoHide", autoHide);
  },

  setTabBarVisibility: function() {
    this.setAutoHidePref();
    if (gHideTabBar == 2) {
      gBrowser.mStrip.collapsed = true;
    }
    else if (gBrowser.mStrip.collapsed) {
      // if we are in multi-row and we have more then one tab we need to initialize multi-row again
      gBrowser.mTabContainer.collapsedTabs = 0;
      setTabBarHeight(false);
      gBrowser.mTabContainer.removeAttribute("multibar");
      var moreThenOneTab = gBrowser.mTabContainer.childNodes.length > 1;
      if (moreThenOneTab || gHideTabBar == 0)
        gBrowser.mStrip.collapsed = false;
      if (moreThenOneTab) {
         tabBarScrollStatus();
         gBrowser.mTabContainer.ensureTabIsVisible(gBrowser.mTabContainer.selectedIndex);
         checkBeforeAndAfter();
      }
    }
  },

  // we replace some Tabmix settings with Firefox settings
  updateSettings: function() {
    if (tabxPrefs.prefHasUserValue("undoCloseCache")) {
       var max_tabs_undo = tabxPrefs.getIntPref("undoCloseCache");
       tabxPrefs.clearUserPref("undoCloseCache");
       gPref.setIntPref("browser.sessionstore.max_tabs_undo", max_tabs_undo);
    }
  }

}

function TMtabBarScroll (event)
{
  var tabs = getBrowser().mTabContainer.childNodes;
  var tabBar = getBrowser().mTabContainer;

  for (var i = 0; i < tabs.length; i++)
    tabs[i].setAttribute("showbutton","off");

  var ScrollDirection = event.detail > 0 ? 1 : -1;
  if (gPref.getBoolPref("extensions.tabmix.reversedScroll"))
    ScrollDirection = -1 * ScrollDirection;

  var shouldMoveFocus = gPref.getBoolPref("extensions.tabmix.enableScrollSwitch");
  if (shouldMoveFocus)
    tabBar.advanceSelectedTab(ScrollDirection, true);
  else if ( gPref.getIntPref("extensions.tabmix.tabBarMode") != 2 )
    tabBar.collapsedTabs += ScrollDirection;
  else if ( gPref.getIntPref("extensions.tabmix.tabBarMode") == 2 )
    tabBar.rowScroll(ScrollDirection);
}

// adjust attribute when we close 2nd tab (we left with only one) or when we open 2nd tab
var adjustOn2ndTab = {
  /*
   *  Disable\enable cmd_close ( Ctrl+W ) when we have only one tab open:
   *    -  if pref (extensions.tabmix.keepWindow) Do not close window when closing last tab by hotkey is true and tabbar is collapsed
   *    -  if pref (extensions.tabmix.keepLastTab) Prevent last tab from closing is true and tabbar is NOT collapsed
   */
   cmdClose: function adjust_cmdClose(aNumTabs) {
   return;
      var cmd_close = document.getElementById("cmd_close");
      if (gBrowser.mTabContainer.childNodes.length == aNumTabs) {
         var tabBarCollapsed = gPref.getBoolPref("browser.tabs.autoHide");
         var keepLastTab = gPref.getBoolPref("extensions.tabmix.keepLastTab") && !tabBarCollapsed;
         var keepWindow = gPref.getBoolPref("extensions.tabmix.keepWindow") && tabBarCollapsed;
         if (keepLastTab || keepWindow) {
            if (!cmd_close.hasAttribute("TMP_disabled")) {
               cmd_close.setAttribute("TMP_disabled", cmd_close.getAttribute("disabled") == "true");
               TMP_setItem("cmd_close", "disabled", true);
            }
            return;
         }
      }
      if (cmd_close.hasAttribute("TMP_disabled")) {
         TMP_setItem(cmd_close, "disabled", cmd_close.getAttribute("TMP_disabled") == "true" || null);
         TMP_setItem(cmd_close, "TMP_disabled", null);
      }

   },

  /*  don't show close tab button if there is only one blank tab or we keep last tab
   *  or if tab width is smaller then pref and not in flexTabs mode.
   */
   closeButton: function adjust_closeButton(aNumTabs, oldTab) {
      var tabBar = gBrowser.mTabContainer;
      var tabs = tabBar.childNodes;
      var aTab = aNumTabs == 2 && tabs[0] == oldTab ? tabs[1] : tabs[0];
      if (tabs.length == aNumTabs &&
               (TMP_getBoolPref(tabxBranch, "keepLastTab", false) || gBrowser.isBlankNotBusyTab(aTab)))
         tabBar.setAttribute("hidebutton", "true");
      else if (tabBar.hasAttribute("hidebutton"))
         tabBar.removeAttribute("hidebutton");

      setTimeout( function(tabBar) {
         // make sure not to check collapsed tab for width
         var width = tabBar.lastChild.boxObject.width;
         // 0 width is an invalid value and indicates an item without display,
         // so ignore.
         var tabClipWidth = TMP_getIntPref("", "browser.tabs.tabClipWidth", 140);
         var attributeChanged = false;
         if (addtabx != 5 || flexTabs || width > tabClipWidth || width == 0) {
            if (tabBar.hasAttribute("tinywidth")) {
               tabBar.removeAttribute("tinywidth");
               attributeChanged = true;
            }
         }
         else if (!tabBar.hasAttribute("tinywidth")) {
            tabBar.setAttribute("tinywidth", "true");
            attributeChanged = true;
         }

         if (attributeChanged) {
            tabBarScrollStatus();
            checkBeforeAndAfter();
         }
      }, 0, tabBar);
   }
}

// in Firefox 2.0 with safebrowsing
// if the current Browser has problem and message is showing we need to
// repaint the "safebrowsing-dim-area-canvas" if we add or remove tabs and
// if we change tabbar position
//
// we don't need this in Firefox 3.0
function adjustSafebrowsingDimArea() {
   if (gIsFirefox3 || !gIsFirefox2)
      return;

   var sbC = safebrowsing.controller;
   if (sbC == null)
      return;

   var browser = getBrowser().selectedBrowser;
   if (sbC.browserView_.hasProblem(browser)) {
      var displayer = sbC.browserView_.getCurrentProblem_(browser).displayer_;
      if (displayer.messageShowing_) {
         displayer.hideMessage_();
         displayer.showMessage_();
      }
   }
}

function TMP_getBoolPref(branch, prefname, def )
{
  try {
    if (!gPref)
      gPref = getPref();
    return gPref.getBoolPref(branch+prefname);
  }
  catch(er) {
    gPref.setBoolPref(branch+prefname, def);
    return def;
  }
}

function TMP_getIntPref(branch, prefname, def )
{
  try {
    if (!gPref)
      gPref = getPref();
    return gPref.getIntPref(branch+prefname);
  }
  catch(er) {
    gPref.setIntPref(branch+prefname, def);
    return def;
  }
}

function TMP_getCharPref(branch, prefname, def )
{
  try {
    if (!gPref)
      gPref = getPref();
    return gPref.getCharPref(branch+prefname);
  }
  catch(er) {
    gPref.setCharPref(branch+prefname, def);
    return def;
  }
}

function getPref()
{
   return Components.classes["@mozilla.org/preferences-service;1"]
            .getService(Components.interfaces.nsIPrefBranch);
}

var TMP_ProgressListener = {

   startup: function TMP_PL_startup(tabBrowser) {
      eval("tabBrowser.enterTabbedMode ="+tabBrowser.enterTabbedMode.toString().replace(
         'filter.addProgressListener(listener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);',
         'listener = TMP_ProgressListener.init(listener); \ $&'
      ));

      eval("tabBrowser.addTab ="+tabBrowser.addTab.toString().replace(
         'var tabListener = this.mTabProgressListener(t, b, blank);',
         '$& \ tabListener = TMP_ProgressListener.init(tabListener);'
      ));
   },

   init: function TMP_PL_init(progressListener) {
      var _this = "TMP_ProgressListener."
/*
// XXX this is not working in firefox 1.0.x ???
      eval("progressListener.onProgressChange = " + progressListener.onProgressChange.toString()
            .replace(/}$/,
            'this.onStateChange(aWebProgress, aRequest);' +
            _this + 'setTabProgress(this.mTab, aMaxTotalProgress, aCurTotalProgress); \ $&'));
*/

      function addToTheEnd(fnName, newString) {
         var fnString = progressListener[fnName].toString();
         fnString = fnString.substr(0, fnString.length - 2) + newString + "}";
         eval("progressListener." + fnName + " = " + fnString);
      }

      addToTheEnd('onProgressChange',
                  'this.onStateChange(aWebProgress, aRequest);' +
                  _this + 'setTabProgress(this.mTab, aMaxTotalProgress, aCurTotalProgress);');

      // we need to be compatible with XHTML Ruby Support
      var fnName = "onStateChange";
      var ruby = "__rubysupport__" + fnName;
      if (ruby in progressListener)
         fnName = ruby;

      eval("progressListener." + fnName + " = " + progressListener[fnName].toString().replace(
            'this.mTab.setAttribute("busy", "true");',
            _this + 'setTabWidth(this.mTab, aRequest.QueryInterface(nsIChannel).URI.spec);'
            + '$&'
         ).replace(
            'var location = aRequest.QueryInterface(nsIChannel).URI;',
            _this + 'setUnreadTab(this.mTab); \ $&'
         ));

      addToTheEnd(fnName,
                  _this + 'setAutoReload(this.mTab, this.mBrowser, aStateFlags);');

      // XXX how to do this with Regexp and replace ?
      var string = "if (this.mTabBrowser.mCurrentTab == this.mTab)";
      var split_fn = progressListener[fnName].toString().split(string);
      split_fn[1] += _this + 'updateSessionManager(this.mTab);'
      eval("progressListener." + fnName + " = " + split_fn.join(string));

      addToTheEnd('onLocationChange', _this + 'fixBug355253(this.mBrowser);')

      return progressListener;

   },

   setTabProgress: function TMP_PL_setTabProgress(aTab, aMaxTotalProgress, aCurTotalProgress) {
      if (gHideTabBar == 2 || aMaxTotalProgress < 1)
         return;
      var percentage = parseInt((aCurTotalProgress * 100) / aMaxTotalProgress);
      if (percentage > 0 && percentage < 100)
         aTab.setAttribute("tab-progress", percentage);
   },

   setTabWidth: function TMP_PL_setTabWidth(aTab, aLocation) {
      var tabBar = aTab.parentNode;
      var spacer = 0;
      if (tabBar.childNodes.length == 1) {
        var hidebutton = (aLocation == "about:blank") || tabxPrefs.getBoolPref("keepLastTab");
        if (tabBar.hasAttribute("hidebutton") && !hidebutton)
          spacer = 5;
        TMP_setItem(tabBar, "hidebutton", hidebutton || null);
      }
      if (gHideTabBar != 2 && widthFitTitle && !aTab.hasAttribute("width") && aLocation != aTab.label) {
         if (aTab.hasAttribute("newtab")) {
           spacer = 5;
           aTab.removeAttribute("newtab");
         }
         aTab.setAttribute("width", aTab.boxObject.width + spacer);
      }
   },

   setUnreadTab: function TMP_PL_setUnreadTab(aTab) {
      aTab.removeAttribute("tab-progress");
      if (gPref.getBoolPref("extensions.tabmix.unreadTab") &&
            aTab.hasAttribute("selected") &&
            gPref.getBoolPref("extensions.tabmix.unreadTabreload") &&
            aTab.getAttribute("selected") == "false")
         aTab.removeAttribute("selected");
   },

   updateSessionManager: function TMP_PL_updateSessionManager(aTab) {
      if (!aTab.hasAttribute("busy"))
         SessionManager.tabLoaded(aTab);
   },

   setAutoReload: function TMP_PL_setAutoReload(aTab, aBrowser, aStateFlags) {
      const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
      if ((aStateFlags & nsIWebProgressListener.STATE_IS_WINDOW) &&
            (aStateFlags & nsIWebProgressListener.STATE_STOP)) {
         if (aTab.autoReloadURI)
            gBrowser.onTabReloaded(aTab, aBrowser);

         // disabled name for locked tab, so locked tab don't get reuse
         if (aTab.getAttribute("locked") && aBrowser.contentWindow.name)
            aBrowser.contentWindow.name = "";
      }
   },

// XXX temp fix to bug 355253
   // recently closed tabs doesn't saved closed tab if it have "about:blank" first in history.
   fixBug355253: function TMP_PL_fixBug355253(aBrowser) {
      var history = aBrowser.webNavigation.sessionHistory;
      if (history && history.count == 2 && history.index == 1 &&
            history.getEntryAtIndex(0, false).URI.spec == "about:blank") {
         aBrowser.observe(null, "browser:purge-session-history", null);
         var backCommand = document.getElementById("Browser:Back");
         if (backCommand)
            backCommand.setAttribute("disabled", "true");
      }
   }

}
